﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data.SqlClient;
using Microsoft.SqlServer.Management.Smo;
using Microsoft.SqlServer.Management.Common;
using System.Windows.Forms;

namespace Isargaran.Classes
{
    class BackupRestore
    {
        public static bool BackupDatabase(string ConnectionStr, string filename)
        {
            try
            {

                System.Data.SqlClient.SqlConnection con = new System.Data.SqlClient.SqlConnection(ConnectionStr);
                con.Open();
                ServerConnection Srvcon = new ServerConnection(con);
                Server Srv = new Server(Srvcon);
                BackupDeviceItem bdi = new BackupDeviceItem(filename, DeviceType.File);
                Backup backup = new Backup();

                backup.Devices.Add(bdi);
                backup.Action = BackupActionType.Database;
                backup.BackupSetDescription = "Backup DataBase";
                backup.BackupSetName = "DB";
                backup.Database = con.Database.ToString();
                backup.LogTruncation = BackupTruncateLogType.Truncate;

                backup.SqlBackup(Srv);
                return true;
            }
            catch(Exception e)
            {
                MessageBox.Show(e.Message);
                return false;
            }
        }

        public static bool RestoreDatabase(string ConnectionStr, string filename)
        {
            try
            {

                System.Data.SqlClient.SqlConnection con = new System.Data.SqlClient.SqlConnection(ConnectionStr);
                con.Open();
                con.ChangeDatabase("master");
                ServerConnection Srvcon = new ServerConnection(con);
                Server Srv = new Server(Srvcon);
                BackupDeviceItem bdi = new BackupDeviceItem(filename, DeviceType.File);
                Restore restore = new Restore();

                restore.Devices.Add(bdi);
                restore.NoRecovery = false;
                restore.ReplaceDatabase = true;
                restore.Database = filename;
                Srv.KillAllProcesses(con.Database);

                restore.SqlRestore(Srv);
                return true;
            }
            catch(Exception ex)
            {
                MessageBox.Show(ex.Message);
                return false;
            }

        }




        public  static bool BACKUP(string filename)
        {
            try
            {
                SqlConnection objcon = new SqlConnection();
                objcon.ConnectionString = System.Data.Sql.SQL_Commands.sqlProvider;
                SqlCommand objcom = new SqlCommand();
                objcom.Connection = objcon;
                string t = @"BACKUP DATABASE [DB_ESARGARANEND]TO DISK=N'" + filename + "' WITH NOFORMAT,NOINIT,NAME=N'mydb-full Database Backup',SKIP,NOREWIND,NOUNLOAD,STATS=10;";
                objcom.CommandText = t;
                objcon.Open();
                objcom.ExecuteNonQuery();
                objcon.Close();

                return true;
            }
            catch(Exception e)
            {
                MessageBox.Show(e.Message);
                return false;
            }

        }
        public static bool RESTORE(string filename)
        {
            try
            {
                SqlConnection SqlCon = new SqlConnection();
                SqlCon.ConnectionString = System.Data.Sql.SQL_Commands.sqlProvider;
                SqlCommand SqlCom = new SqlCommand();
                SqlCom.Connection = SqlCon;
                SqlCon.Open();
                SqlCom.CommandText = "ALTER DATABASE DB_ESARGARANEND SET SINGLE_USER WITH ROLLBACK IMMEDIATE USE master; RESTORE DATABASE DB_ESARGARANEND FROM DISK =N'" + filename + "'";
                SqlCom.Connection = SqlCon;
                SqlCom.ExecuteNonQuery();
                SqlCon.Close();

                SqlCon.Open();
                SqlCom.CommandText = "ALTER DATABASE DB_ESARGARANEND SET MULTI_USER ";
                SqlCom.Connection = SqlCon;
                SqlCom.ExecuteNonQuery();
                SqlCon.Close();

                return true;
            }
            catch(Exception e)
            {
                return false;
            }

        }



    }
}


