﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Collections;
using Microsoft.SqlServer.Management.Common;
using Microsoft.SqlServer.Management.Smo;
using System.Data.SqlClient;

namespace Isargaran
{
    public partial class frmRestorebackup : Form
    {
        private string fileName;
        public System.ServiceProcess.ServiceController sc = new System.ServiceProcess.ServiceController("MSSQL$SQLEXPRESS");
        
        public frmRestorebackup(string FN)
        {
            InitializeComponent();
            fileName = FN;
        }

        private void BackupProgress_Load(object sender, EventArgs e)
        {

        }

        public void RestoreBackup()
        {
         if (sc.Status==System.ServiceProcess.ServiceControllerStatus.Stopped)
            sc.Start();
            button1.Enabled = false;
            backgroundWorker1.RunWorkerAsync();

        }

        protected delegate void Backup_PercentCompleteDelegate(object sender, PercentCompleteEventArgs e);


        protected void Backup_PercentComplete(
            object sender, PercentCompleteEventArgs e)
        {
            if (this.InvokeRequired)
                this.Invoke(new Backup_PercentCompleteDelegate(Backup_PercentComplete), sender, e);
            else
                progressBar1.Value = e.Percent;
        }
        protected delegate void Backup_CompleteDelegate(object sender, ServerMessageEventArgs e);

        protected void Backup_Complete(object sender, ServerMessageEventArgs e)
        {
            if (this.InvokeRequired)
                this.Invoke(new Backup_CompleteDelegate(Backup_Complete), sender, e);
            else
            {
                label1.ForeColor = Color.Green;
                label1.Text = "عملیات بازیابی  با موفقیت به اتمام رسید!";
                button1.Enabled = true;

            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            this.Close();
            Application.Restart();
        }

        private void backgroundWorker1_DoWork(object sender, DoWorkEventArgs e)
        {
            string sConnect = Properties.Settings.Default.DB_ESARGARANENDConnectionString;
            string dbName;

            using (SqlConnection cnn = new SqlConnection(sConnect))
            {
                try
                {
                    cnn.Open();
                    dbName = cnn.Database.ToString();
                    cnn.ChangeDatabase("master");

                    ServerConnection sc = new ServerConnection(cnn);
                    Server sv = new Server(sc);

                    // Check that I'm connected to the user instance
                    //MessageBox.Show(sv.InstanceName.ToString());

                    // Create backup device item for the backup
                    BackupDeviceItem bdi = new BackupDeviceItem(fileName, DeviceType.File);

                    // Create the restore object
                    Restore resDB = new Restore();
                    resDB.Devices.Add(bdi);
                    resDB.NoRecovery = false;
                    resDB.ReplaceDatabase = true;
                    resDB.Database = dbName;
                    resDB.PercentComplete += new PercentCompleteEventHandler(Backup_PercentComplete);
                    resDB.Complete += new ServerMessageEventHandler(Backup_Complete);
                    // Restore the database
                    resDB.SqlRestore(sv);
                }
                catch (Exception ex)
                {
                    label1.ForeColor = Color.Red;
                    MessageBox.Show("اشکال در بازیابی اطلاعات \n  لطفا دوباره تلاش نمایید");
                            
                }
                
                // MessageBox.Show("Your database has been restored.");

            }
        }

        private void frmRestorebackup_Load(object sender, EventArgs e)
        {

        }


    }
}


